#if defined _jbe_authority_menu
  #endinput
#endif
#define _jbe_authority_menu

/***********************************************************************************************************************************/

/** [ Краткая информация ]
	
	* [Лимит] - Означает, что достигнут лимит в использовании предмета.
	* [Ж] - Означает, что предмет доступен лишь, когда игрок жив.
	* [M] - Означает, что предмет доступен лишь, когда игрок мёртв.
*/

#define PREFIX "^4[GOLD]^1"

#define JBE_AUTHORITY_IGNORED 1		//Блокирует взятие предмета
#define JBE_AUTHORITY_CONTINUE 0	//Не блокирует взятие предмета

/*=================================================================================================================================
	[ `AM` - Всё, что касается менюшки. ]
===================================================================================================================================*/
/** [ RegisterAuthorityItem ]

	* Регестрация предметов в меню привилегий.
	
	* 'szName' - Название предмета.
	* 'iLimit' - Лимит на использование.
	* 'iType' - Тип отображения в меню.
	* 'bNeedPlayers' - Выводить ли меню с выбором игроков?!
	* 'iNeedTeams' - Игроки какой команды будут доступны в меню ?!
	* 'iPlayersType' - Тип отображения игроков в меню.
	* 'bMe' - Показывать ли меня в меню с игроками ?!

	* [ 'iType' ]
	* '-1' - Отображается в меню как для живого, так и для мёртвого человека.
	* '0' - Отображается только для мёртвого человека.
	* '1' - Отображается только для живого человека.
	
	* [ 'bNeedPlayers' ]
	* 'false' - Не выдаётся меню с выбором жертвы.
	* 'true' - Выдаётся меню с выбором жертвы.
	
	* [ 'iNeedTeams' ]
	* '1' - Отображаются лишь зэки.
	* '2' - Отображаются лишь охранники.
	
	* [ 'iNeedTeams' ]
	* '-1' - Отображаются игроки обеих команд.
	* '1' - Отображаются лишь зэки.
	* '2' - Отображаются лишь охранники.
	
	* [ 'iNeedTeams' ]
	* '-1' - Отображается в меню живая и мёртвая жертва.
	* '0' - Отображается в меню только мёртвая жертва.
	* '1' - Отображается в меню только живая жертва.
	
	* [ 'bMe' ]
	* 'false' - Не отображать себя в меню мёртв.
	* 'true' - Отображать себя в меню мёртв.
	
	* [ 'Важно' ]
	* При `iLimit` = -1 ограничение на использование отсутствует.
	* Любое ограничение выставляется на протяжении лишь одной карты.
*/
native RegisterAuthorityItem(const szName[], iLimit = 0, iType = -1, bool:bNeedPlayers = false, iNeedTeams = -1, iPlayersType = -1, bool:bMe = false);

/** [ Jbe_AuthorityItemSelected ]

	* Вызывается, когда игрок выбрал пункт в меню привилегий.
	
	* 'pId' - Индекс игрока.
	* 'iItemId' - Индекс выбранного предмета.
	* 'pIde' - Индекс жертвы.
*/
forward Jbe_AuthorityItemSelected(pId, iItemId, pIde);



















