 /* -> Режимы -> */

//Поднимаем информер
native jbe_informer_offset_up(id);

//Опускаем информер
native jbe_informer_offset_down(id);

// Узнаем, какой сегодня по счету день
native jbe_get_day();

// Устанавливаем, какой по счету день
native jbe_set_day();

// Узнаем, какой день недели
native jbe_get_day_week();

// Устанавливаем, какой по день недели
native jbe_set_day_week();

// Узнаем, какой режим
native jbe_get_day_mode();

// Устанавливаем, режим
native jbe_set_day_mode();

/** [ jbe_register_day_mode ]
   
   * Регестрация игрового дня
   * 
   * 'szLang[32]' - Название игры для информера и меню
   * 'iBlock' - раз в сколько рнд может быть запущена игра
   * 'iTime' - сколько идет по времени игра
*/
native jbe_register_day_mode(szLang[32], iBlock, iTime);

/* -> Двери -> */

// Открываем двери в камерах
native jbe_open_doors();

// Закрываем двери в камерах
native jbe_close_doors();

/* -> Деньги -> */

// Получаем кол-во денег у игрока
native jbe_get_user_money(pPlayer);

/** [ jbe_set_user_money ]
   
   * Устанавливаем кол-во денег у игрока
   * 
   * 'pPlayer' - Индекс игрока
   * 'iNum' - количество устанавливаемых денег
   * 'iFlash' - сделать ли блик денег после выдачи (0 - нет | 1 - да)
*/
native jbe_set_user_money(pPlayer, iNum, iFlash);			// Устанавливаем кол-во денег у игрока

/* -> Команда -> */

// Получаем команду игрока
native jbe_get_user_team(pPlayer);

/** [ jbe_set_user_team ]
   
   * Устанавливаем команду игрока
   * 
   * 'pPlayer' - Индекс игрока
   * 'iTeam' - за кого перевести игрока
 
   * ['iTeam']
   * '0'            //Наблюдатели
   * '1'            //Заключенные
   * '2'            //Охранники
*/
native jbe_set_user_team(pPlayer, iTeam);

/* -> Модели -> */

/** [ jbe_get_user_model ]
   
   * Получаем модель игрока
   * 
   * 'pPlayer' - Индекс игрока
   * 'const szModel[]' - название модели
   * 'iLen' - сохраняем полученные данные в массив
*/
native jbe_get_user_model(pPlayer, const szModel[], iLen);

/** [ jbe_set_user_model ]
   
   * Устанавливаем модель игроку
   * 
   * 'pPlayer' - Индекс игрока
   * 'const szModel[]' - название модели
*/
native jbe_set_user_model(pPlayer, const szModel[]);

// Меняем Sub-Модель игрока			
native jbe_prisoners_divide_color(iTeam);

/* -> Проверки -> */

// Живой или нет
native jbe_is_user_alive(pPlayer);		

// Подключен или нет
native jbe_is_user_connected(pPlayer);

// Проверка, участник дуэли или нет
native jbe_is_user_duel(pPlayer);

/* -> Меню -> */

// Блокируем меню игроку
native jbe_menu_block(pPlayer);

// Разблокировка меню игрока
native jbe_menu_unblock(pPlayer);

// Проверем блокировку
native jbe_menu_blocked(pPlayer);

/* -> FreeDay | Wanted | Voice -> */

// **Личное фд** //

// Узнаем, имеет-ли свободный день игрок игрок
native jbe_is_user_free(pPlayer);

// Даем свободный день
native jbe_add_user_free(pPlayer);

// Даем свободный день в следуйщем раунде
native jbe_add_user_free_next_round(pPlayer);

// Забираем свободный день
native jbe_sub_user_free(pPlayer);

// **Глобальное фд** //

// Начинаенм глобальный свободный день
native jbe_free_day_start();

// Заканчиваем глобальный свободный день
native jbe_free_day_ended();

// **Розыск** //

// Узнаем, в розыске-ли игрок
native jbe_is_user_wanted(pPlayer);

// Даем розыск
native jbe_add_user_wanted(pPlayer);

// Забираем розыск
native jbe_sub_user_wanted(pPlayer);

// **Голос** //

// Узнаем, наличие голоса
native jbe_get_user_voice(pPlayer);

// Даем голос
native jbe_set_user_voice(pPlayer);

// Даем голос в следуйщем раунде
native jbe_set_user_voice_next_round(pPlayer);

/* -> Работа с начальником -> */

// Узнаем, начальник-ли игрок
native jbe_is_user_chief(pPlayer);

// Выдем начальника
native jbe_set_user_chief(pPlayer);

// Живой/мертвый/отключенный - начальник
native jbe_get_chief_status(pPlayer);

/* -> Костюмы -> */

/** [ jbe_set_user_costumes ]
   
   * Даем шапку игроку
   * 
   * 'pPlayer' - Индекс игрока
   * 'iCostumes' - Индекс шапки
*/
native jbe_set_user_costumes(pPlayer, iCostumes);

// Прячем шапку
native jbe_hide_user_costumes(pPlayer);

/* -> Свечение -> */

/** [ jbe_set_user_costumes ]
   
   * Получаем свечение
   * 
   * 'pPlayer' - Индекс игрока
   * '&iRenderFx' - Render FX
   * '&iRed' - Красный цвет (до 255)
   * '&iGreen' - Зеленный цвет (до 255)
   * '&iBlue' - Голубой цвет (до 255)
   * '&iRenderMode' - Тип свечения
   * '&iRenderAmt' - Минимальный порог свечения
*/
native jbe_get_user_rendering(pPlayer, &iRenderFx, &iRed, &iGreen, &iBlue, &iRenderMode, &iRenderAmt);

// Устанавливаем свечение
/// PS. Смотреть значения выше
native jbe_set_user_rendering(pPlayer, iRenderFx, iRed, iGreen, iBlue, iRenderMode, iRenderAmt); 

// Восстановление свечения игрока
native jbe_restoring_user_rendering(pPlayer);