#if определено _reapi_engine_const_included
	#endinput
#endif

#define  _reapi_engine_const_included

/ * *
* Для родного rh_get_mapname
* /
enum MapNameType
{
	MNT_TRUE ,    // возвращает исходное имя карты независимо от имени, установленного с помощью rh_set_mapname
	MNT_SET      // вернуть имя текущей карты
};

/ * *
* rh_emit_sound2 flags
* /
#define  SND_EMIT2_NOPAS    BIT ( 0 )  // Никогда не проверять PAS
#define  SND_EMIT2_INVOKER  BIT ( 1 )  // Не отправлять клиенту invoker

/ * *
* enum EngineFunc
* /
enum EngineFunc
{
	/ *
	* Описание: -
	* Параметры: (постоянные получатели, постоянная сущность, постоянный канал, постоянная выборка [], постоянная громкость, Float: затухание, const fFlags, постоянная высота)
	* /
	RH_SV_StartSound =  BEGIN_FUNC_REGION ( двигатель ),

	/ *
	* Описание: -
	* Параметры: (постоянный клиент, bool: сбой, постоянный fmt [])
	* /
	RH_SV_DropClient ,

	/ *
	* Описание: -
	* Параметры: (const runPhysics)
	* /
	RH_SV_ActivateServer ,

	/ *
	* Описание: -
	* Параметры: (pcvar, const value [])
	* /
	RH_Cvar_DirectSet ,

	/ *
	* Описание: Receiver - индекс игрока или 0, когда обновление будет отправлено всем.
	* Параметры: (постоянный клиент, буфер, постоянный получатель)
	* /
	RH_SV_WriteFullClientUpdate ,
};

/ * *
* enum EntVars
* /
enum EntVars
{
	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	имя_класса =  BEGIN_MEMBER_REGION ( entvars ),

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_globalname ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_origin ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_oldorigin ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_velocity ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_basevelocity ,

	/ *
	* Описание: Базовая скорость, которая была передана физике сервера, чтобы клиент мог правильно прогнозировать конвейеры. Сервер обнуляет его, поэтому мы должны хранить его и здесь.
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_clbasevelocity ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_movedir ,

	/ *
	* Описание: модель углов.
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_angles ,

	/ *
	* Описание: Угловая скорость (градусы в секунду).
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_avelocity ,

	/ *
	* Описание: Авто-затухающая регулировка угла обзора.
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_punchangle ,

	/ *
	* Описание: угол обзора (только для игрока).
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_v_angle ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_endpos ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_startpos ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_impacttime ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_starttime ,

	/ *
	* Описание: 0: ничего, 1: углы обзора силы, 2: добавить скорость
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_fixangle ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_idealpitch ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_pitch_speed ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_ideal_yaw ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_yaw_speed ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_modelindex ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_model ,

	/ *
	* Описание: модель просмотра игрока.
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_viewmodel ,

	/ *
	* Описание: модель, которую видят другие игроки.
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_weaponmodel ,

	/ *
	* Описание: BB min переведено в мировые координаты.
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_absmin ,

	/ *
	* Описание: BB max переведен в мировые координаты.
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_absmax ,

	/ *
	* Описание: местный BB мин.
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_mins ,

	/ *
	* Описание: локальный BB макс.
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_maxs ,

	/ *
	* Описание: макс - мин
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_size ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_ltime ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_nextthink ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_movetype ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_solid ,

	/ *
	* Описание: Выбор скина для студийных моделей.
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_skin ,

	/ *
	* Описание: выбор подмоделей для студийных моделей.
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_body ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_effects ,

	/ *
	* Описание:% от "нормальной" силы тяжести.
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_gravity ,

	/ *
	* Описание: обратная эластичность MOVETYPE_BOUNCE
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_friction ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_light_level ,

	/ *
	* Описание: последовательность анимации.
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_sequence ,

	/ *
	* Описание: последовательность анимации движения для игрока (0 - нет)
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_gaitsequence ,

	/ *
	* Описание:% позиции воспроизведения в анимационных последовательностях (0..255)
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_frame ,

	/ *
	* Описание: Мировое время, когда был установлен кадр.
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_animtime ,

	/ *
	* Описание: скорость воспроизведения анимации (от -8x до 8x)
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_framerate ,

	/ *
	* Описание: настройка контроллера кости (0..255)
	* Тип элемента: байт [4]
	* Получить параметры: get_entvar (index, EntVars: var, element);
	* Установить параметры: set_entvar (index, EntVars: var, value, element);
	* /
	var_controller ,

	/ *
	* Описание: количество смешивания между подпоследовательностями (0..255)
	* Тип элемента: байт [2]
	* Получить параметры: get_entvar (index, EntVars: var, element);
	* Установить параметры: set_entvar (index, EntVars: var, value, element);
	* /
	var_blending ,

	/ *
	* Описание: Шкала рендеринга спрайтов (0..255)
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_scale ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_rendermode ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_renderamt ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_rendercolor ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_renderfx ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_health ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_frags ,

	/ *
	* Описание: битовая маска для доступного оружия
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_weapons ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_takedamage ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_deadflag ,

	/ *
	* Описание: положение глаз
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_view_ofs ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	кнопка var_ ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_impulse ,

	/ *
	* Описание: указатель сущности при связывании в связанный список.
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_chain ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_dmg_inflictor ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_enemy ,

	/ *
	* Описание: указатель объекта при MOVETYPE_FOLLOW
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_aiment ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_owner ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_groundentity ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_spawnflags ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_flags ,

	/ *
	* Описание: нижний верхний цвет, нижний верхний цвет
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_colormap ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_team ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_max_health ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_teleport_time ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_armortype ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_armorvalue ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_waterlevel ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_watertype ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_target ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_targetname ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_netname ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_message ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_dmg_take ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_dmg_save ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_dmg ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_dmgtime ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_noise ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_noise1 ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_noise2 ,

	/ *
	* Описание: -
	* Тип элемента: string_t
	* Получить параметры: get_entvar (index, EntVars: var, dest [], const длина);
	* Установить параметры: set_entvar (index, EntVars: var, const source []);
	* /
	var_noise3 ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_speed ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_air_finished ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_pain_finished ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_radsuit_finished ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_pContainedEntity ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_playerclass ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_maxspeed ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_fov ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_weaponanim ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_pushmsec ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_bInDuck ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_flTimeStepSound ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_flSwimTime ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_flDuckTime ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_iStepLeft ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, Float: value);
	* /
	var_flFallVelocity ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_gamestate ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_oldbuttons ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_groupinfo ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_iuser1 ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_iuser2 ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_iuser3 ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_iuser4 ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_fuser1 ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_fuser2 ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_fuser3 ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_fuser4 ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_vuser1 ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_vuser2 ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_vuser3 ,

	/ *
	* Описание: -
	* Тип члена: класс Vector
	* Получить параметры: get_entvar (index, EntVars: var, Float: output [3]);
	* Установить параметры: set_entvar (index, EntVars: var, Float: dest [3]);
	* /
	var_vuser4 ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_euser1 ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_euser2 ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_euser3 ,

	/ *
	* Описание: -
	* Тип элемента: struct edict_s *
	* Получить параметры: get_entvar (index, EntVars: var);
	* Установить параметры: set_entvar (index, EntVars: var, value);
	* /
	var_euser4
};

/ * *
* enum UCmd
* /
enum UCmd
{
	/ *
	* Описание: -
	* Тип члена: короткий
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, value);
	* /
	ucmd_lerp_msec =  BEGIN_MEMBER_REGION ( usercmd ),

	/ *
	* Описание: -
	* Тип элемента: байт
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, value);
	* /
	ucmd_msec ,

	/ *
	* Описание: -
	* Тип члена: vec3_t
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var, Float: output [3]);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, Float: dest [3]);
	* /
	ucmd_viewangles ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, Float: value);
	* /
	ucmd_forwardmove ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, Float: value);
	* /
	ucmd_sidemove ,

	/ *
	* Описание: -
	* Тип члена: float
	* Получить параметры: Float: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, Float: value);
	* /
	ucmd_upmove ,

	/ *
	* Описание: -
	* Тип элемента: байт
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, value);
	* /
	ucmd_lightlevel ,

	/ *
	* Описание: -
	* Тип члена: неподписанный короткий
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, value);
	* /
	ucmd_buttons ,

	/ *
	* Описание: -
	* Тип элемента: байт
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, value);
	* /
	ucmd_impulse ,

	/ *
	* Описание: -
	* Тип элемента: байт
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, value);
	* /
	ucmd_weaponselect ,

	/ *
	* Описание: -
	* Тип члена: int
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, value);
	* /
	ucmd_impact_index ,

	/ *
	* Описание: -
	* Тип члена: vec3_t
	* Получить параметры: get_ucmd (const ucmd, UserCmd: var, Float: output [3]);
	* Установить параметры: set_ucmd (const ucmd, UserCmd: var, Float: dest [3]);
	* /
	ucmd_impact_position
};