#include <amxmodx>
#include <amxmisc>
#include <fakemeta>
#include <fakemeta_util>

#define PREFIX "Костюмы" 
#define DICTIONARY "custom_costume.txt" 

#define MAX_MODELS 4
#define MAX_MODELS_HEAD 46								//Максимально шапок для головы(При добавление указать!)
#define MAX_MODELS_BACK 11								//Максимально шапок для спины(При добавление указать!)
#define MAX_MODELS_PELVIS 4								//Максимально шапок для зада(При добавление указать!)
#define MAX_MODELS_FACE 3								//Максимально шапок для лица(При добавление указать!)
#define PLAYERS_PER_PAGE 8

//#define NATIVE_INFORMER
#if defined NATIVE_INFORMER
native jbe_informer_offset_up(id)						//Раскоментируете если для джайл мода
#endif

new g_iMenuPosition[33][4], g_CostumeModelBack[33], g_CostumeModelFace[33], g_CostumeModelHead[64], g_CostumeModelPelvis[33], 
costume_back[33], costume_head[64], costume_pelvis[33], costume_face[33],bool:g_HadCostumeModel[33]

new const CostumeModels[MAX_MODELS][] =
{
    "models/jb_engine/costumes/jbe_costumes_12_sub_back.mdl",
    "models/jb_engine/costumes/jbe_costumes_4_sub_face.mdl",
    "models/jb_engine/costumes/jbe_costumes_47_sub_head.mdl", 
    "models/jb_engine/costumes/jbe_costumes_5_sub_pelvis.mdl"
}

public plugin_init()
{
	register_plugin("[Hats] Costumes", "1.0", "Limbo")
	register_menucmd(register_menuid("Show_CostumesMenu"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<8|1<<9), "Handle_CostumesMenu");
	register_menucmd(register_menuid("Show_HeadCosMenu"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<6|1<<7|1<<8|1<<9), "Handle_HeadCosmenu");
	register_menucmd(register_menuid("Show_FaceCosMenu"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<6|1<<7|1<<8|1<<9), "Handle_FaceCosmenu");
	register_menucmd(register_menuid("Show_PelvisCosMenu"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<6|1<<7|1<<8|1<<9), "Handle_PelvisCosmenu");
	register_menucmd(register_menuid("Show_BackCosMenu"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<6|1<<7|1<<8|1<<9), "Handle_BackCosmenu");
	register_dictionary(DICTIONARY)
}
public Cmd_CostumesMenu(id) return Show_CostumesMenu(id)

public plugin_natives() register_native("Cmd_CostumesMenu", "Cmd_CostumesMenu", 1)

public client_putinserver(id)
{
    g_CostumeModelBack[id] = 0
    g_CostumeModelFace[id] = 0
    g_CostumeModelHead[id] = 0
    g_CostumeModelPelvis[id] = 0
    costume_back[id] = 0
    costume_head[id] = 0
    costume_pelvis[id] = 0
    costume_face[id] = 0
    g_HadCostumeModel[id] = false
}

public client_disconnect(id)
{
    g_CostumeModelBack[id] = 0
    g_CostumeModelFace[id] = 0
    g_CostumeModelHead[id] = 0
    g_CostumeModelPelvis[id] = 0
    costume_back[id] = 0
    costume_head[id] = 0
    costume_pelvis[id] = 0
    costume_face[id] = 0
    g_HadCostumeModel[id] = false
}

public plugin_precache()
{
	for(new i = 0; i < MAX_MODELS; i++) precache_model(CostumeModels[i])
}

Show_CostumesMenu(id)
{
	new szMenu[512], iKeys = (1<<0|1<<1|1<<2|1<<3|1<<4|1<<8|1<<9), 
	iLen = formatex(szMenu, charsmax(szMenu), "\y%L^n^n", id, "JBE_CHOOSE_CATEGORY");
	#if defined NATIVE_INFORMER
	jbe_informer_offset_up(id);
	#endif
	iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r1\d] \y%L^n^n", id, "JBE_NO_COSTUME");
	iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r2\d] \w%L^n", id, "JBE_HEAD");
	iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r3\d] \w%L^n", id, "JBE_FACE");
	iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r4\d] \w%L^n", id, "JBE_BACK");
	iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r5\d] \w%L^n", id, "JBE_PELVIS");

	formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\r0\d] \w%L", id, "JBE_MENU_EXIT");
	return show_menu(id, iKeys, szMenu, -1, "Show_CostumesMenu");
}

public Handle_CostumesMenu(id, iKey)
{
	switch(iKey)
	{
		case 0: 
		{  
			if(!g_HadCostumeModel[id])
			{
				print_colorchat(id, "!g[%s] !n%L", PREFIX, LANG_PLAYER, "JBE_NF_COSTUME")    
			}
			else
			{
				reset_costume(id, 1)
				reset_costume(id, 2)
				reset_costume(id, 3)
				reset_costume(id, 4)
				costume_back[id] = 0
				costume_head[id] = 0
				costume_pelvis[id] = 0
				costume_face[id] = 0
				print_colorchat(id, "!g[%s] !n%L", PREFIX, LANG_PLAYER, "JBE_REMOVED") 
				g_HadCostumeModel[id] = false
			}
		}
		case 1: return head_menu(id)
		case 2: return face_menu(id)
		case 3: return back_menu(id)
		case 4: return pelvis_menu(id)
		case 9: return PLUGIN_HANDLED
	}
	return PLUGIN_HANDLED
}

head_menu(id) return Show_HeadCosMenu(id, g_iMenuPosition[id][3] = 0);
Show_HeadCosMenu(id, iPos)
{
	if(iPos < 0) return PLUGIN_HANDLED;
	#if defined NATIVE_INFORMER
	jbe_informer_offset_up(id);
	#endif
	new iStart = iPos * PLAYERS_PER_PAGE;
	if(iStart > MAX_MODELS_HEAD) iStart = MAX_MODELS_HEAD;
	iStart = iStart - (iStart % 8);
	g_iMenuPosition[id][3] = iStart / PLAYERS_PER_PAGE;
	new iEnd = iStart + PLAYERS_PER_PAGE;
	if(iEnd > MAX_MODELS_HEAD) iEnd = MAX_MODELS_HEAD + (iPos ? 0 : 1);
	new szLangPlayer[33], szMenu[512], iLen, iPagesNum = (MAX_MODELS_HEAD / PLAYERS_PER_PAGE + ((MAX_MODELS_FACE % PLAYERS_PER_PAGE) ? 1 : 0))
	iLen = formatex(szMenu, charsmax(szMenu), "\y%L \w[%d|%d]^n^n", id, "JBE_CHOOSE_COSTUME", iPos + 1, iPagesNum);
	new iKeys = (1<<9), b;
	for(new a = iStart; a < iEnd; a++)
	{
		formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_HEAD_%d", a);
		new temp = a+1
		if(costume_head[id] != temp)
		{	
			iKeys |= (1<<b);
			iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \w%L^n", ++b, id, szLangPlayer);
			}
			else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \d%L \r[\yВыбран\r]^n", ++b, id, szLangPlayer);
	}
	for(new i = b; i < PLAYERS_PER_PAGE; i++) iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n");
	if(iEnd < MAX_MODELS_HEAD)
	{
		iKeys |= (1<<8);
		formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\r9\d] \w%L^n\d[\r0\d] \w%L", id, "JBE_MENU_NEXT", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	}
	else formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n^n\d[\r0\d] \w%L", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	return show_menu(id, iKeys, szMenu, -1, "Show_HeadCosMenu");
}

public Handle_HeadCosmenu(id, iKey)
{
	switch(iKey)
	{
		case 8: return Show_HeadCosMenu(id, ++g_iMenuPosition[id][3]);
		case 9: return Show_HeadCosMenu(id, --g_iMenuPosition[id][3]);
		default:
		{
			new iCostumes = g_iMenuPosition[id][3] * PLAYERS_PER_PAGE + iKey;
			reset_costume(id, 2)
			make_costume(id, CostumeModels[2],2, iCostumes)
			new szLangPlayer[33]
			formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_HEAD_%d", iKey);
			print_colorchat(id, "!g[%s] !n%L: !g%L", PREFIX, LANG_PLAYER, "JBE_CHOOSED", id, szLangPlayer) 
			g_HadCostumeModel[id] = true
			costume_head[id] = iCostumes + 1
			return Show_HeadCosMenu(id, g_iMenuPosition[id][3]);
		}
	}
	return PLUGIN_HANDLED;
}

face_menu(id) return Show_FaceCosMenu(id, g_iMenuPosition[id][2] = 0);
Show_FaceCosMenu(id, iPos)
{
	if(iPos < 0) return PLUGIN_HANDLED;
	#if defined NATIVE_INFORMER
	jbe_informer_offset_up(id);
	#endif
	new iStart = iPos * PLAYERS_PER_PAGE;
	if(iStart > MAX_MODELS_FACE) iStart = MAX_MODELS_FACE;
	iStart = iStart - (iStart % 8);
	g_iMenuPosition[id][2] = iStart / PLAYERS_PER_PAGE;
	new iEnd = iStart + PLAYERS_PER_PAGE;
	if(iEnd > MAX_MODELS_FACE) iEnd = MAX_MODELS_FACE + (iPos ? 0 : 1);
	new szLangPlayer[33], szMenu[512], iLen, iPagesNum = (MAX_MODELS_FACE / PLAYERS_PER_PAGE + ((MAX_MODELS_FACE % PLAYERS_PER_PAGE) ? 1 : 0));
	iLen = formatex(szMenu, charsmax(szMenu), "\y%L \w[%d|%d]^n^n", id, "JBE_CHOOSE_COSTUME", iPos + 1, iPagesNum);
	new iKeys = (1<<9), b;
	for(new a = iStart; a < iEnd; a++)
	{
		formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_FACE_%d", a);
		new temp = a+1
		if(costume_face[id] != temp)
		{	
			iKeys |= (1<<b);
			iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \w%L^n", ++b, id, szLangPlayer);
			}
			else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \d%L \r[\yВыбран\r]^n", ++b, id, szLangPlayer);
	}
	for(new i = b; i < PLAYERS_PER_PAGE; i++) iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n");
	if(iEnd < MAX_MODELS_FACE)
	{
		iKeys |= (1<<8);
		formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\r9\d] \w%L^n\d[\r0\d] \w%L", id, "JBE_MENU_NEXT", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	}
	else formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n^n\d[\r0\d] \w%L", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	return show_menu(id, iKeys, szMenu, -1, "Show_FaceCosMenu");
}

public Handle_FaceCosmenu(id, iKey)
{
	switch(iKey)
	{
		case 8: return Show_FaceCosMenu(id, ++g_iMenuPosition[id][2]);
		case 9: return Show_FaceCosMenu(id, --g_iMenuPosition[id][2]);
		default:
		{
			new iCostumes = g_iMenuPosition[id][2] * PLAYERS_PER_PAGE + iKey;
			reset_costume(id, 4)
			make_costume(id, CostumeModels[1],4, iCostumes)
			new szLangPlayer[33]
			formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_FACE_%d", iKey);
			print_colorchat(id, "!g[%s] !n%L: !g%L", PREFIX, LANG_PLAYER, "JBE_CHOOSED", id, szLangPlayer) 
			g_HadCostumeModel[id] = true  
			costume_face[id] = iCostumes + 1	
			return Show_FaceCosMenu(id, g_iMenuPosition[id][2]);
		}
	}
	return PLUGIN_HANDLED;
}

pelvis_menu(id) return Show_PelvisCosMenu(id, g_iMenuPosition[id][1] = 0);
Show_PelvisCosMenu(id, iPos)
{
	if(iPos < 0) return PLUGIN_HANDLED;
	#if defined NATIVE_INFORMER
	jbe_informer_offset_up(id);
	#endif
	new iStart = iPos * PLAYERS_PER_PAGE;
	if(iStart > MAX_MODELS_PELVIS) iStart = MAX_MODELS_PELVIS;
	iStart = iStart - (iStart % 8);
	g_iMenuPosition[id][1] = iStart / PLAYERS_PER_PAGE;
	new iEnd = iStart + PLAYERS_PER_PAGE;
	if(iEnd > MAX_MODELS_PELVIS) iEnd = MAX_MODELS_PELVIS + (iPos ? 0 : 1);
	new szLangPlayer[33], szMenu[512], iLen, iPagesNum = (MAX_MODELS_PELVIS / PLAYERS_PER_PAGE + ((MAX_MODELS_PELVIS % PLAYERS_PER_PAGE) ? 1 : 0));
	iLen = formatex(szMenu, charsmax(szMenu), "\y%L \w[%d|%d]^n^n", id, "JBE_CHOOSE_COSTUME", iPos + 1, iPagesNum);
	new iKeys = (1<<9), b;
	for(new a = iStart; a < iEnd; a++)
	{
		formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_PELVIS_%d", a);
		new temp = a+1
		if(costume_pelvis[id] != temp)
		{	
			iKeys |= (1<<b);
			iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \w%L^n", ++b, id, szLangPlayer);
			}
			else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \d%L \r[\yВыбран\r]^n", ++b, id, szLangPlayer);
	}
	for(new i = b; i < PLAYERS_PER_PAGE; i++) iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n");
	if(iEnd < MAX_MODELS_PELVIS)
	{
		iKeys |= (1<<8);
		formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\r9\d] \w%L^n\d[\r0\d] \w%L", id, "JBE_MENU_NEXT", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	}
	else formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n^n\d[\r0\d] \w%L", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	return show_menu(id, iKeys, szMenu, -1, "Show_PelvisCosMenu");
}

public Handle_PelvisCosmenu(id, iKey)
{
	switch(iKey)
	{
		case 8: return Show_PelvisCosMenu(id, ++g_iMenuPosition[id][1]);
		case 9: return Show_PelvisCosMenu(id, --g_iMenuPosition[id][1]);
		default:
		{
			new iCostumes = g_iMenuPosition[id][1] * PLAYERS_PER_PAGE + iKey;
			reset_costume(id, 3)
			make_costume(id, CostumeModels[3],3, iCostumes)
			new szLangPlayer[33]
			formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_PELVIS_%d", iKey);
			print_colorchat(id, "!g[%s] !n%L: !g%L", PREFIX, LANG_PLAYER, "JBE_CHOOSED", id, szLangPlayer) 
			g_HadCostumeModel[id] = true  
			costume_pelvis[id] = iCostumes + 1
			return Show_PelvisCosMenu(id, g_iMenuPosition[id][1]);
		}
	}
	return PLUGIN_HANDLED;
}

back_menu(id) return Show_BackCosMenu(id, g_iMenuPosition[id][0] = 0);
Show_BackCosMenu(id, iPos)
{
	if(iPos < 0) return PLUGIN_HANDLED;
	#if defined NATIVE_INFORMER
	jbe_informer_offset_up(id);
	#endif
	new iStart = iPos * PLAYERS_PER_PAGE;
	if(iStart > MAX_MODELS_BACK) iStart = MAX_MODELS_BACK;
	iStart = iStart - (iStart % 8);
	g_iMenuPosition[id][0] = iStart / PLAYERS_PER_PAGE;
	new iEnd = iStart + PLAYERS_PER_PAGE;
	if(iEnd > MAX_MODELS_BACK) iEnd = MAX_MODELS_BACK + (iPos ? 0 : 1);
	new szLangPlayer[33], szMenu[512], iLen, iPagesNum = (MAX_MODELS_BACK / PLAYERS_PER_PAGE + ((MAX_MODELS_BACK % PLAYERS_PER_PAGE) ? 1 : 0));
	iLen = formatex(szMenu, charsmax(szMenu), "\y%L \w[%d|%d]^n^n", id, "JBE_CHOOSE_COSTUME", iPos + 1, iPagesNum);
	new iKeys = (1<<9), b;
	for(new a = iStart; a < iEnd; a++)
	{
		formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_BACK_%d", a);
		new temp = a+1
		if(costume_back[id] != temp)
		{	
			iKeys |= (1<<b);
			iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \w%L^n", ++b, id, szLangPlayer);
			}
			else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\r%d\d] \d%L \r[\yВыбран\r]^n", ++b, id, szLangPlayer);
	}
	for(new i = b; i < PLAYERS_PER_PAGE; i++) iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n");
	if(iEnd < MAX_MODELS_BACK)
	{
		iKeys |= (1<<8);
		formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\r9\d] \w%L^n\d[\r0\d] \w%L", id, "JBE_MENU_NEXT", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	}
	else formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n^n\d[\r0\d] \w%L", id, iPos ? "JBE_MENU_BACK" : "JBE_MENU_EXIT");
	return show_menu(id, iKeys, szMenu, -1, "Show_BackCosMenu");
}

public Handle_BackCosmenu(id, iKey)
{
	switch(iKey)
	{
		case 8: return Show_BackCosMenu(id, ++g_iMenuPosition[id][0]);
		case 9: return Show_BackCosMenu(id, --g_iMenuPosition[id][0]);
		default:
		{
			new iCostumes = g_iMenuPosition[id][0] * PLAYERS_PER_PAGE + iKey;
			reset_costume(id, 1)
			make_costume(id, CostumeModels[0],1, iCostumes)
			new szLangPlayer[33]
			formatex(szLangPlayer, charsmax(szLangPlayer), "JBE_MENU_COSTUMES_BACK_%d", iKey);
			print_colorchat(id, "!g[%s] !n%L: !g%L", PREFIX, LANG_PLAYER, "JBE_CHOOSED", id, szLangPlayer) 
			g_HadCostumeModel[id] = true  
			costume_back[id] = iCostumes + 1	
			return Show_BackCosMenu(id, g_iMenuPosition[id][0]);
		}
	}
	return PLUGIN_HANDLED;
}

public make_costume(id, model[],part, anim)
{	
	switch(part)
	{
		case 1:
        {
			g_CostumeModelBack[id] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	
			set_pev(g_CostumeModelBack[id], pev_movetype, MOVETYPE_FOLLOW)
			set_pev(g_CostumeModelBack[id], pev_aiment, id)
			set_pev(g_CostumeModelBack[id], pev_rendermode, 	kRenderNormal)
			engfunc(EngFunc_SetModel, g_CostumeModelBack[id], model)
			set_pev(g_CostumeModelBack[id], pev_body, anim)
			set_pev(g_CostumeModelBack[id], pev_sequence, anim)
			set_pev(g_CostumeModelBack[id], pev_animtime, get_gametime())
			set_pev(g_CostumeModelBack[id], pev_framerate, 1.0)
        }
        case 2:
        {
			g_CostumeModelHead[id] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	
			set_pev(g_CostumeModelHead[id], pev_movetype, MOVETYPE_FOLLOW)
			set_pev(g_CostumeModelHead[id], pev_aiment, id)
			set_pev(g_CostumeModelHead[id], pev_rendermode, 	kRenderNormal)
			engfunc(EngFunc_SetModel, g_CostumeModelHead[id], model)
			set_pev(g_CostumeModelHead[id], pev_body, anim)
			set_pev(g_CostumeModelHead[id], pev_sequence, anim)
			set_pev(g_CostumeModelHead[id], pev_animtime, get_gametime())
			set_pev(g_CostumeModelHead[id], pev_framerate, 1.0)
        }
        case 3:
        {
			g_CostumeModelPelvis[id] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	
			set_pev(g_CostumeModelPelvis[id], pev_movetype, MOVETYPE_FOLLOW)
			set_pev(g_CostumeModelPelvis[id], pev_aiment, id)
			set_pev(g_CostumeModelPelvis[id], pev_rendermode, 	kRenderNormal)
			engfunc(EngFunc_SetModel, g_CostumeModelPelvis[id], model)
			set_pev(g_CostumeModelPelvis[id], pev_body, anim)
			set_pev(g_CostumeModelPelvis[id], pev_sequence, anim)
			set_pev(g_CostumeModelPelvis[id], pev_animtime, get_gametime())
			set_pev(g_CostumeModelPelvis[id], pev_framerate, 1.0)
        }
        case 4:
        {
			g_CostumeModelFace[id] = engfunc(EngFunc_CreateNamedEntity, engfunc(EngFunc_AllocString, "info_target"))	
			set_pev(g_CostumeModelFace[id], pev_movetype, MOVETYPE_FOLLOW)
			set_pev(g_CostumeModelFace[id], pev_aiment, id)
			set_pev(g_CostumeModelFace[id], pev_rendermode, 	kRenderNormal)
			engfunc(EngFunc_SetModel, g_CostumeModelFace[id], model)
			set_pev(g_CostumeModelFace[id], pev_body, anim)
			set_pev(g_CostumeModelFace[id], pev_sequence, anim)
			set_pev(g_CostumeModelFace[id], pev_animtime, get_gametime())
			set_pev(g_CostumeModelFace[id], pev_framerate, 1.0)
        }
	}
}

public reset_costume(id, number)
{
    switch(number)
    {
	case 1:
	{
	   fm_set_entity_visibility(g_CostumeModelBack[id], 0)
	   g_CostumeModelBack[id] = 0
	}
	case 2:
	{
	   fm_set_entity_visibility(g_CostumeModelHead[id], 0)
	   g_CostumeModelHead[id] = 0
	}
	case 3:
	{
	   fm_set_entity_visibility(g_CostumeModelPelvis[id], 0)
	   g_CostumeModelPelvis[id] = 0
	}
	case 4:
	{
	   fm_set_entity_visibility(g_CostumeModelFace[id], 0)
	   g_CostumeModelFace[id] = 0
	}
    }
}

stock print_colorchat(id, String[], any:...)
{
    new SzMsg[192]
    vformat(SzMsg, charsmax(SzMsg), String, 3)    
    replace_all(SzMsg, charsmax(SzMsg), "!n", "^1")
    replace_all(SzMsg, charsmax(SzMsg), "!t", "^3")
    replace_all(SzMsg, charsmax(SzMsg), "!g", "^4")
    static msgSayText = 0
    static fake_user    
    if(!msgSayText)
    {
        msgSayText = get_user_msgid("SayText")
        fake_user = get_maxplayers() + 1
    }    
    message_begin(id ? MSG_ONE_UNRELIABLE : MSG_BROADCAST, msgSayText, _, id)
    write_byte(id ? id : fake_user)
    write_string(SzMsg)
    message_end()
}