#include <amxmodx>
#include <fakemeta>
#include <hamsandwich>
#include <jbe_core>

#define linux_diff_player 5
#define PLAYERS_PER_PAGE 7
#define MAX_MODELS 64
#define MsgId_SayText 76
#define m_iPlayerTeam 114
#define TASK_SETSUBMODEL 787724
#define TASK_SETMODEL 878234

#define MENU_FLAG ADMIN_LEVEL_A

enum _:DATA_INFOMODELS
{
	LANG_MODELNAME[64],
	LANG_MODELFILE[32],
	LANG_PLAYERAUTCH[32],
	TYPE_CHECKACCES,
	MODEL_TEAM,
	ADD_MENU,
	SUBMODEL
};

new Array:g_aDataPlayerModel, g_iPlayerModelSize, g_iPlayerModel[33], g_iPlayerModels[33][MAX_MODELS], g_iUserPlayerModelSize[33], 
g_iMaxPlayers, g_iMenuPosition[33], g_iMenuModels[33][MAX_MODELS];


public plugin_init()
{
	register_plugin("***[DEAD]~[MODELS]***", "2.0", "[VaMpIr] DEAD");
	register_dictionary("player_models.txt");
	register_clcmd("jbe_new_models_l", "ClCmd_ModelsMenu");
	register_menucmd(register_menuid("Show_ModelsMenu"), (1<<0|1<<1|1<<2|1<<3|1<<4|1<<5|1<<6|1<<7|1<<8|1<<9), "Handle_ModelsMenu");
	RegisterHam(Ham_Spawn, "player", "Ham_PlayerSpawn_Post", true);
	g_iMaxPlayers = get_maxplayers();
}

public plugin_precache()
{
	new szCfgDir[64], szCfgFile[128];
	get_localinfo("amxx_configsdir", szCfgDir, charsmax(szCfgDir));
	formatex(szCfgFile, charsmax(szCfgFile), "%s/jb_engine/GOLD_INI/admin_models.ini", szCfgDir);
	switch(file_exists(szCfgFile))
	{
		case 0: log_to_file("%s/log_error.log", "File ^"%s^" not found!", szCfgDir, szCfgFile);
		case 1:
		{
			new szBuffer[128], szParse[4][8], aDataPlayerModel[DATA_INFOMODELS], iLine, iLen;
			g_aDataPlayerModel = ArrayCreate(DATA_INFOMODELS);
			while(read_file(szCfgFile, iLine++, szBuffer, charsmax(szBuffer), iLen))
			{
				if(!iLen || szBuffer[0] == ';') continue;
				parse(szBuffer, aDataPlayerModel[LANG_MODELNAME], charsmax(aDataPlayerModel[LANG_MODELNAME]), aDataPlayerModel[LANG_MODELFILE], 
				charsmax(aDataPlayerModel[LANG_MODELFILE]), aDataPlayerModel[LANG_PLAYERAUTCH], charsmax(aDataPlayerModel[LANG_PLAYERAUTCH]), 
				szParse[0], charsmax(szParse[]), szParse[1], charsmax(szParse[]), szParse[2], charsmax(szParse[]), szParse[3], charsmax(szParse[]));
				switch(szParse[0][0])
				{
					case 's': aDataPlayerModel[TYPE_CHECKACCES] = 1;
					case 'i': aDataPlayerModel[TYPE_CHECKACCES] = 2;
					case 'f': aDataPlayerModel[TYPE_CHECKACCES] = 3;
					default : aDataPlayerModel[TYPE_CHECKACCES] = 0;
				}
				aDataPlayerModel[MODEL_TEAM] = str_to_num(szParse[1]);
				aDataPlayerModel[ADD_MENU] = str_to_num(szParse[2]);
				aDataPlayerModel[SUBMODEL] = str_to_num(szParse[3]);
				formatex(szBuffer, charsmax(szBuffer), "models/player/%s/%s.mdl", aDataPlayerModel[LANG_MODELFILE], aDataPlayerModel[LANG_MODELFILE]);
				engfunc(EngFunc_PrecacheModel, szBuffer);
				ArrayPushArray(g_aDataPlayerModel, aDataPlayerModel);
				if(++g_iPlayerModelSize == MAX_MODELS) break;
			}
		}
	}
}

public client_disconnect(id)
{
	if(task_exists(id + TASK_SETSUBMODEL)) remove_task(id + TASK_SETSUBMODEL);
	g_iPlayerModel[id] = 0;
	if(g_iUserPlayerModelSize[id])
	{
		for(new i; i < g_iUserPlayerModelSize[id]; i++) g_iPlayerModels[id][i] = 0;
		g_iUserPlayerModelSize[id] = 0;
	}
}

public client_putinserver(id)
{
	new szAutch[4][32], aDataPlayerModel[DATA_INFOMODELS];
	get_user_name(id, szAutch[0], charsmax(szAutch[]));
	get_user_authid(id, szAutch[1], charsmax(szAutch[]));
	get_user_ip(id, szAutch[2], charsmax(szAutch[]), 1);
	get_flags(get_user_flags(id), szAutch[3], charsmax(szAutch[]));
	for(new i; i < g_iPlayerModelSize; i++)
	{
		ArrayGetArray(g_aDataPlayerModel, i, aDataPlayerModel);
		if(aDataPlayerModel[TYPE_CHECKACCES] < 3)
		{
			if(equali(szAutch[aDataPlayerModel[TYPE_CHECKACCES]], aDataPlayerModel[LANG_PLAYERAUTCH]))
			{
				if(!g_iUserPlayerModelSize[id]) g_iPlayerModel[id] = i+1;
				g_iPlayerModels[id][g_iUserPlayerModelSize[id]] = i+1;
				g_iUserPlayerModelSize[id]++;
			}
		}
		else if(contain(szAutch[aDataPlayerModel[TYPE_CHECKACCES]], aDataPlayerModel[LANG_PLAYERAUTCH]) != -1)
		{
			if(!g_iUserPlayerModelSize[id]) g_iPlayerModel[id] = i+1;
			g_iPlayerModels[id][g_iUserPlayerModelSize[id]] = i+1;
			g_iUserPlayerModelSize[id]++;
		}
	}
}

public ClCmd_ModelsMenu(id) return Show_ModelsMenu(id, g_iMenuPosition[id] = 0);
public Show_ModelsMenu(id, iPos)
{
	if(iPos < 0) return PLUGIN_HANDLED;
	if(!g_iPlayerModelSize)
	{
		UTIL_SayText(id, "%L", id, "PM_CHAT_MODELS_BLANCK");
		return PLUGIN_HANDLED;
	}
	new aDataPlayerModel[DATA_INFOMODELS], iModelsNum;
	for(new i; i < g_iPlayerModelSize; i++)
	{
		ArrayGetArray(g_aDataPlayerModel, i, aDataPlayerModel);
		if(!aDataPlayerModel[ADD_MENU]) continue;
		g_iMenuModels[id][iModelsNum++] = i;
	}
	new iStart = (iPos * PLAYERS_PER_PAGE);
	if(iStart > iModelsNum) iStart = iModelsNum;
	iStart = iStart - (iStart % 7);
	g_iMenuPosition[id] = iStart / PLAYERS_PER_PAGE;
	new iEnd = iStart + PLAYERS_PER_PAGE;
	if(iEnd > iModelsNum) iEnd = iModelsNum;
	new szMenu[512], iLen, iPagesNum = (iModelsNum / PLAYERS_PER_PAGE + ((iModelsNum % PLAYERS_PER_PAGE) ? 1 : 0));
	switch(iPagesNum)
	{
		case 0:
		{
			UTIL_SayText(id, "%L", id, "PM_CHAT_MODELS_BLANCK");
			return PLUGIN_HANDLED;
		}
		default: iLen = formatex(szMenu, charsmax(szMenu), "\d%L \y[%d/%d]^n^n", LANG_PLAYER, "PM_MODELS_MENU_TITLE", iPos + 1, iPagesNum);
	}
	new iKeys = (1<<9), b, iModel;
	for(new a = iStart; a < iEnd; a++)
	{
		iModel = g_iMenuModels[id][a];
		ArrayGetArray(g_aDataPlayerModel, iModel, aDataPlayerModel);
		if((check_player_models(id, iModel, aDataPlayerModel[LANG_MODELFILE]) && (fm_get_user_team(id) == aDataPlayerModel[MODEL_TEAM] || !aDataPlayerModel[MODEL_TEAM])) 
		|| get_user_flags(id) & MENU_FLAG)
		{
			if(g_iPlayerModel[id] != iModel+1)
			{
				iKeys |= (1<<b);
				iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\y%d\d] \w%s^n", ++b, aDataPlayerModel[LANG_MODELNAME]);
			}
			else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\y%d\d] %s\y*^n", ++b, aDataPlayerModel[LANG_MODELNAME]);
		}
		else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "\d[\y%d\d] \d%s^n", ++b, aDataPlayerModel[LANG_MODELNAME]);
	}
	for(new i = b; i < PLAYERS_PER_PAGE; i++) iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n");
	if(g_iPlayerModel[id])
	{
		iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\y8\d] \w%L", id, "PM_MODELS_MENU_CLEAR");
		iKeys |= (1<<7);
	}
	else iLen += formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\y8\d] \d%L \r[#]", id, "PM_MODELS_MENU_CLEAR");
	if(iEnd < iModelsNum)
	{
		iKeys |= (1<<8);
		formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n^n\r\d[\y9\d] \w%L^n\r\d[\y0\d] \w%L", id, "PM_MENU_NEXT", id, iPos ? "PM_MENU_BACK" : "PM_MENU_EXIT");
	}
	else formatex(szMenu[iLen], charsmax(szMenu) - iLen, "^n\d[\y0\d] \w%L", id, iPos ? "PM_MENU_BACK" : "PM_MENU_EXIT");
	return show_menu(id, iKeys, szMenu, -1, "Show_ModelsMenu");
}

public Handle_ModelsMenu(id, iKey)
{
	switch(iKey)
	{
		case 7:
		{
			if(is_user_alive(id)) jbe_default_model(id);
			g_iPlayerModel[id] = 0;
		}
		case 8: return Show_ModelsMenu(id, ++g_iMenuPosition[id]);
		case 9: return Show_ModelsMenu(id, --g_iMenuPosition[id]);
		default:
		{
			new aDataPlayerModel[DATA_INFOMODELS], iModel = g_iMenuModels[id][g_iMenuPosition[id] * PLAYERS_PER_PAGE + iKey];
			ArrayGetArray(g_aDataPlayerModel, iModel, aDataPlayerModel);
			if(fm_get_user_team(id) == aDataPlayerModel[MODEL_TEAM] || !aDataPlayerModel[MODEL_TEAM])
			{
				if(is_user_alive(id))
				{
					if(task_exists(id + TASK_SETSUBMODEL)) remove_task(id + TASK_SETSUBMODEL);
					jbe_set_user_model(id, aDataPlayerModel[LANG_MODELFILE]);
					new szBuffer[2]; szBuffer[0] = id;
					szBuffer[1] = aDataPlayerModel[SUBMODEL];
					set_task(0.11, "Task_SetSubModel", id + TASK_SETSUBMODEL, szBuffer, sizeof(szBuffer));
				}
				g_iPlayerModel[id] = iModel + 1;
			}
		}
	}
	return Show_ModelsMenu (id, g_iMenuPosition[id]);
}

public Ham_PlayerSpawn_Post(id) if(is_user_alive(id) && g_iPlayerModel[id] && !task_exists(id + TASK_SETMODEL)) set_task(0.1, "Task_SetModel", id + TASK_SETMODEL);
public Task_SetModel(pPlayer)
{
	pPlayer -= TASK_SETMODEL;
	if(task_exists(pPlayer + TASK_SETSUBMODEL)) remove_task(pPlayer + TASK_SETSUBMODEL);
	if(!is_user_alive(pPlayer)) return;
	new aDataPlayerModel[DATA_INFOMODELS]; ArrayGetArray(g_aDataPlayerModel, g_iPlayerModel[pPlayer]-1, aDataPlayerModel);
	if(fm_get_user_team(pPlayer) == aDataPlayerModel[MODEL_TEAM] || !aDataPlayerModel[MODEL_TEAM])
	{
		jbe_set_user_model(pPlayer, aDataPlayerModel[LANG_MODELFILE]);
		new szBuffer[2]; szBuffer[0] = pPlayer;
		szBuffer[1] = aDataPlayerModel[SUBMODEL];
		set_task(0.11, "Task_SetSubModel", pPlayer + TASK_SETSUBMODEL, szBuffer, sizeof(szBuffer));
	}
}

public Task_SetSubModel(szBuffer[2]) set_pev(szBuffer[0], pev_body, szBuffer[1]);
public check_player_models(pPlayer, iModel, szModel[])
{
	new aDataPlayerModel[DATA_INFOMODELS];
	for(new i; i < g_iUserPlayerModelSize[pPlayer]; i++)
	{
		ArrayGetArray(g_aDataPlayerModel, g_iPlayerModels[pPlayer][i]-1, aDataPlayerModel);
		if(g_iPlayerModels[pPlayer][i] == iModel+1 || equali(aDataPlayerModel[LANG_MODELFILE], szModel)) return 1;
	}
	return 0;
}

stock fm_get_user_team(pPlayer) return get_pdata_int(pPlayer, m_iPlayerTeam, linux_diff_player);
stock UTIL_SayText(pPlayer, const szMessage[], any:...)
{
	new szBuffer[190];
	if(numargs() > 2) vformat(szBuffer, charsmax(szBuffer), szMessage, 3);
	else copy(szBuffer, charsmax(szBuffer), szMessage);
	while(replace(szBuffer, charsmax(szBuffer), "!y", "^1")) {}
	while(replace(szBuffer, charsmax(szBuffer), "!t", "^3")) {}
	while(replace(szBuffer, charsmax(szBuffer), "!g", "^4")) {}
	switch(pPlayer)
	{
		case 0:
		{
			for(new iPlayer = 1; iPlayer <= g_iMaxPlayers; iPlayer++)
			{
				if(!is_user_connected(iPlayer)) continue;
				engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, MsgId_SayText, {0.0, 0.0, 0.0}, iPlayer);
				write_byte(iPlayer);
				write_string(szBuffer);
				message_end();
			}
		}
		default:
		{
			engfunc(EngFunc_MessageBegin, MSG_ONE_UNRELIABLE, MsgId_SayText, {0.0, 0.0, 0.0}, pPlayer);
			write_byte(pPlayer);
			write_string(szBuffer);
			message_end();
		}
	}
}