#include <amxmodx> 
#include <cstrike> 
#include <fakemeta> 
#include <amxmisc>

#define VERSION "0.1" 

new const g_Sounds[][] = 
{ 
    "weapons/knife_hit1.wav",                // Knife 
    "weapons/knife_hit2.wav",                // Knife 
    "weapons/knife_hit3.wav",                // Knife 
    "weapons/knife_hit4.wav",                // Knife 
    "weapons/knife_slash1.wav",                // Knife 
    "weapons/knife_hitwall1.wav",            // Knife 
    "weapons/aug-1.wav>",                    // Aug 
    "weapons/aug_clipout.wav",                // Aug 
    "weapons/aug_clipin.wav",                // Aug 
    "weapons/aug_boltpull.wav",                // Aug 
    "weapons/aug_boltslap.wav",                // Aug 
    "weapons/aug_forearm.wav",                // Aug 
    "weapons/sg550-1.wav",                    // sg550 
    "weapons/sg550_boltpull.wav",            // sg550 
    "weapons/sg550_clipin.wav",                // sg550 
    "weapons/sg550_clipout.wav",            // sg550 
    "weapons/sg552-1.wav",                    // sg552 
    "weapons/sg552-2.wav",                    // sg552 
    "weapons/sg552_clipin.wav",                // sg552 
    "weapons/m3-1.wav",                        // m3             
    "weapons/m3_insertshell.wav",            // m3 
    "weapons/m3_pump.wav",                    // m3 
    "weapons/reload1.wav",                    // m3 
    "weapons/reload3.wav",                    // m3 
    "weapons/xm1014-1.wav",                    // m3 & xm1014 
    "weapons/usp1.wav",                        // usp 
    "weapons/usp2.wav",                        // usp 
    "weapons/usp_unsil-1.wav",                // usp 
    "weapons/usp_clipout.wav",                // usp 
    "weapons/usp_clipin.wav",                // usp 
    "weapons/usp_silencer_on.wav",            // usp 
    "weapons/usp_silencer_off.wav",            // usp 
    "weapons/usp_sliderelease.wav",            // usp 
    "weapons/usp_slideback.wav",            // usp 
    "weapons/mac10-1.wav",                    // mac10 
    "weapons/mac10_clipout.wav",            // mac10 
    "weapons/mac10_clipin.wav",                // mac10 
    "weapons/mac10_boltpull.wav",            // mac10 
    "weapons/ump45-1.wav",                    // ump45 
    "weapons/ump45_clipout.wav",            // ump45 
    "weapons/ump45_clipin.wav",                // ump45 
    "weapons/ump45_boltslap.wav",            // ump45 
    "weapons/fiveseven-1.wav",                // fiveseven 
    "weapons/fiveseven_clipout.wav",        // fiveseven 
    "weapons/fiveseven_clipin.wav",            // fiveseven 
    "weapons/fiveseven_sliderelease.wav",    // fiveseven 
    "weapons/fiveseven_slidepull.wav",        // fiveseven 
    "weapons/p90-1.wav",                    // p90 
    "weapons/p90_clipout.wav",                // p90 
    "weapons/p90_clipin.wav",                // p90 
    "weapons/p90_boltpull.wav",                // p90 
    "weapons/p90_cliprelease.wav",            // p90 
    "weapons/deagle-1.wav",                    // Deagle 
    "weapons/deagle-2.wav",                    // Deagle 
    "weapons/de_clipout.wav",                // Deagle 
    "weapons/de_clipin.wav",                // Deagle 
    "weapons/de_deploy.wav",                // Deagle 
    "weapons/p228-1.wav",                    // p228 
    "weapons/p228_clipout.wav",                // p228 
    "weapons/p228_clipin.wav",                // p228 
    "weapons/p228_sliderelease.wav",        // p228 
    "weapons/p228_slidepull.wav",            // p228 
    "weapons/knife_deploy1.wav",            // Knife 
    "weapons/glock18-1.wav",                // glock18                     
    "weapons/glock18-2.wav",                // glock18 
    "weapons/clipout1.wav",                    // 
    "weapons/clipin1.wav",                    // 
    "weapons/sliderelease1.wav",            // 
    "weapons/slideback1.wav",                // 
    "weapons/357_cock1.wav",                // 
    "weapons/mp5-1.wav",                    // mp5 
    "weapons/mp5-2.wav",                    // mp5 
    "weapons/mp5_clipout.wav",                // mp5 
    "weapons/mp5_clipin.wav",                // mp5 
    "weapons/mp5_slideback.wav",            // mp5 
    "weapons/tmp-1.wav",                    // Tmp 
    "weapons/tmp-2.wav",                    // Tmp 
    "weapons/elite_fire.wav",                // elite 
    "weapons/elite_reloadstart.wav",        // elite 
    "weapons/elite_leftclipin.wav",            // elite 
    "weapons/elite_clipout.wav",            // elite 
    "weapons/elite_sliderelease.wav",        // elite 
    "weapons/elite_rightclipin.wav",        // elite 
    "weapons/elite_deploy.wav",                // elite 
    "weapons/flashbang-1.wav",                // Zbyk Dumabyxu 
    "weapons/flashbang-2.wav",                // Zbyk Dumabyxu 
    "weapons/pinpull.wav",                    // 
    "weapons/hegrenade-1.wav",                // 
    "weapons/hegrenade-2.wav",                // 
    "weapons/he_bounce-1.wav",                // 
    "weapons/sg_explode.wav",                // 
    "weapons/c4_click.wav",                    // Nuck Bombu 
    "weapons/galil-1.wav",                    // galil 
    "weapons/galil-2.wav",                    // galil 
    "weapons/galil_clipout.wav",            // galil 
    "weapons/galil_clipin.wav",                // galil 
    "weapons/galil_boltpull.wav",            // galil 
    "weapons/famas-1.wav",                    // Famas 
    "weapons/famas-2.wav",                    // Famas 
    "weapons/famas_clipout.wav",            // Famas 
    "weapons/famas_clipin.wav",                // Famas 
    "weapons/famas_boltpull.wav",            // Famas 
    "weapons/famas_boltslap.wav",            // Famas 
    "weapons/famas_forearm.wav",            // Famas 
    "weapons/famas-burst.wav",                // Famas 
    "weapons/scout_fire-1.wav",                // Scout 
    "weapons/scout_bolt.wav",                // Scout 
    "weapons/scout_clipin.wav",                // Scout 
    "weapons/debris1.wav",                    // Zbyk npoleta IIIalinou nylu 
    "weapons/debris2.wav",                    // Zbyk npoleta IIIalinou nylu 
    "weapons/debris3.wav>",                    // Zbyk npoleta IIIalinou nylu 
    "weapons/grenade_hit1.wav",                // Zbyk gpenu bpode npugayIIIeu 
    "weapons/grenade_hit2.wav",                // Zbyk gpenu bpode npugayIIIeu 
    "weapons/grenade_hit3.wav",                // Zbyk gpenu bpode npugayIIIeu 
    "weapons/bullet_hit1.wav",                // Zbyk nyli nonodauIIIux B Bac 
    "weapons/bullet_hit2.wav",                // Zbyk nyli nonodauIIIux B Bac 
    "items/weapondrop1.wav",                // Bpode zbyk Dpona weapon 
    "weapons/dryfire_pistol.wav",            // Zbyk otcytbu9I natponoB 
    "weapons/dryfire_rifle.wav",            // Zbyk otcytbu9I natponoB 
    "player/pl_shot1.wav",                    // Zbyk zaxlebobanu9I B Bode 
    "player/headshot1.wav",                    // Zbyk nonadanu9I B goloby 
    "player/headshot2.wav",                    // Zbyk nonadanu9I B goloby 
    "player/headshot3.wav",                    // Zbyk nonadanu9I B goloby 
    "radio/locknload.wav",                    // Radio 
    "radio/letsgo.wav",                        // Radio 
    "radio/moveout.wav",                    // Radio 
    "radio/com_go.wav",                        // Radio 
    "radio/rescued.wav",                    // Radio 
    "radio/rounddraw.wav",                    // Radio 
    "items/kevlar.wav",                        //  
    "items/ammopickup2.wav>",                // Zbyk Odebanu9I bponu 
    "items/nvg_off.wav",                    // NVG 
    "items/equip_nvg.wav",                    // NVG 
    "weapons/c4_beep1.wav",                    // C4 
    "weapons/c4_beep2.wav",                    // C4 
    "weapons/c4_beep3.wav",                    // C4 
    "weapons/c4_beep4.wav",                    // C4 
    "weapons/c4_beep5.wav",                    // C4 
    "weapons/c4_explode1.wav",                // C4 
    "weapons/c4_plant.wav",                    // C4 
    "weapons/c4_disarm.wav",                // C4 
    "weapons/c4_disarmed.wav",                // C4 
    "weapons/explode3.wav",                    // Zbyk Bzpuba Gpanatu 
    "weapons/explode4.wav",                    // Zbyk Bzpuba Gpanatu 
    "weapons/explode5.wav",                    // Zbyk Bzpuba Gpanatu 
    "player/sprayer.wav",                    // Zbyk cnpe9I 
    "player/pl_fallpain2.wav",                // 
    "player/pl_fallpain3.wav",                // 
    "common/npc_step1.wav",                    // Zbyk udyIIIero NPC 
    "common/npc_step2.wav",                    // Zbyk udyIIIero NPC 
    "common/npc_step3.wav",                    // Zbyk udyIIIero NPC 
    "common/npc_step4.wav",                    // Zbyk udyIIIero NPC 
    "player/pl_metal1.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_metal2.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_metal3.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_metal4.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_dirt1.wav",                    // Zvyk medlennoro IIIara 
    "player/pl_dirt2.wav",                    // Zvyk medlennoro IIIara 
    "player/pl_dirt3.wav",                    // Zvyk medlennoro IIIara 
    "player/pl_dirt4.wav",                    // Zvyk medlennoro IIIara 
    "player/pl_duct1.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_duct2.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_duct3.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_duct4.wav",                    // Zbyk udyIIIego no metaly 
    "player/pl_grate1.wav",                    // Zbyk udyIIIego no metaly 2 
    "player/pl_grate2.wav",                    // Zbyk udyIIIego no metaly 2 
    "player/pl_grate3.wav",                    // Zbyk udyIIIego no metaly 2 
    "player/pl_grate4.wav",                    // Zbyk udyIIIego no metaly 2 
    "player/pl_slosh1.wav",                    // Zbyk udyIIIero no Boge 
    "player/pl_slosh2.wa",                    // Zbyk udyIIIero no Boge 
    "player/pl_slosh3.wav",                    // Zbyk udyIIIero no Boge 
    "player/pl_slosh4.wav",                    // Zbyk udyIIIero no Boge 
    "player/pl_tile1.wav",                    // Zbyk UdyIIIego no dockam ulu napkety 
    "player/pl_tile2.wav",                    // Zbyk UdyIIIego no dockam ulu napkety 
    "player/pl_tile3.wav",                    // Zbyk UdyIIIego no dockam ulu napkety 
    "player/pl_tile4.wav",                    // Zbyk UdyIIIego no dockam ulu napkety 
    "player/pl_tile5.wav",                    // Zbyk UdyIIIego no dockam ulu napkety 
    "player/pl_swim1.wav",                    // Zbyl nlabuni9I b Bode ulu nup9Inu9I 
    "player/pl_swim2.wav",                    // Zbyl nlabuni9I b Bode ulu nup9Inu9I 
    "player/pl_swim3.wav",                    // Zbyl nlabuni9I b Bode ulu nup9Inu9I 
    "player/pl_swim4.wav",                    // Zbyl nlabuni9I b Bode ulu nup9Inu9I 
    "player/pl_ladder1.wav",                // Zbyl zalazuni9I no lectnuce 
    "player/pl_ladder2.wav",                // Zbyl zalazuni9I no lectnuce 
    "player/pl_ladder3.wav",                // Zbyl zalazuni9I no lectnuce 
    "player/pl_ladder4.wav",                // Zbyl zalazuni9I no lectnuce 
    "player/pl_wade1.wav",                    // Zbyku nepedbu)i(enu9I no neglybokou Bode 
    "player/pl_wade2.wav",                    // Zbyku nepedbu)i(enu9I no neglybokou Bode 
    "player/pl_wade3.wav",                    // Zbyku nepedbu)i(enu9I no neglybokou Bode 
    "player/pl_wade4.wav",                    // Zbyku nepedbu)i(enu9I no neglybokou Bode 
    "debris/wood1.wav",                        // Zbyk lomanu9I Docok 
    "debris/wood2.wav",                        // Zbyk lomanu9I Docok 
    "debris/wood3.wav",                        // Zbyk lomanu9I Docok 
    "plats/train_use1.wav",                    // Zbyk bpode bubukani9I MaIIIunu 
    "plats/vehicle_ignition.wav",            // Zbyk gazobanu9I na moIIIune 
    "buttons/spark5.wav",                    // Zbyk zamukanu9I toka 
    "buttons/spark6.wav",                    // Zbyk zamukanu9I toka 
    "debris/glass1.wav",                    // Zbyk ydapa ctekla 
    "debris/glass2.wav",                    // Zbyk ydapa ctekla 
    "debris/glass3.wav",                    // Zbyk ydapa ctekla 
    "hostage/hos1.wav",                        // Zbyk Pazgobopa c NPC 
    "hostage/hos2.wav",                        // Zbyk Pazgobopa c NPC 
    "hostage/hos3.wav",                        // Zbyk Pazgobopa c NPC 
    "hostage/hos4.wav",                        // Zbyk Pazgobopa c NPC 
    "hostage/hos5.wav",                        // Zbyk Pazgobopa c NPC 
    "common/wpn_hudoff.wav",                // Zbyk nepekly4enu9I megdy Bubopom opygu9I 
    "common/wpn_hudon.wav",                    // Zbyk Bubponoro opygu9I B meny bpode 
    "common/wpn_moveselect.wav",            // Zbyk Buctporo opyru9I B meny 
    "common/wpn_denyselect.wav",            // Zbyk Buctporo opyru9I B meny 
    "common/wpn_select.wav",                // Zbyk Buctporo opyru9I B meny 
    "player/geiger6.wav",                    // Zbyk Paduacuu 
    "player/geiger5.wav",                    // Zbyk Paduacuu 
    "player/geiger4.wav",                    // Zbyk Paduacuu 
    "player/geiger3.wav",                    // Zbyk Paduacuu 
    "player/geiger2.wav",                    // Zbyk Paduacuu 
    "player/geiger1.wav",                    // Zbyk Paduacuu 
    "buttons/bell1.wav",                    // Zbyk Komeptona Bpode 
    "buttons/blip1.wav",                    // Zbyk Muranu9I Fonapukom 
    "buttons/blip2.wav",                    // Zbyk Nukani9I 
    "buttons/button11.wav",                    // 
    "buttons/latchunlocked2.wav",            // 
    "buttons/lightswitch2.wav",                // 
    "ambience/quail1.wav",                    // 
    "events/tutor_msg.wav",                    // 
    "events/enemy_died.wav",                // 
    "events/friend_died.wav",                // 
    "events/task_complete.wav",                // 
    "common/null.wav",                        // 
    "common/bodydrop3.wav",                    // 
    "common/bodydrop4.wav",                    // 
    "weapons/ric1.wav",                        // 
    "weapons/ric2.wav",                        // 
    "weapons/ric3.wav",                        // 
    "weapons/ric4.wav",                        // 
    "weapons/ric5.wav",                        // 
    "weapons/ric_metal-1.wav",                // 
    "weapons/ric_metal-2.wav",                // 
    "buttons/spark1.wav",                    // 
    "buttons/spark2.wav",                    // 
    "buttons/spark3.wav",                    // 
    "buttons/spark4.wav",                    // 
    "debris/bustcrate1.wav",                // 
    "debris/bustcrate2.wav",                // 
    "player/pl_die1.wav"                    // 
}  


public plugin_precache() 
{ 
    register_plugin("UnPrecacher", VERSION, "Proo.Noob") 
    register_forward(FM_PrecacheSound, "PrecacheSound") 
} 


public PrecacheSound(const szSound[]) 
{ 
    for(new i = 0; i < sizeof(g_Sounds); i++) 
    { 
        if( containi(szSound, g_Sounds[i]) != -1 ) 
        { 
            forward_return(FMV_CELL, 0) 
            return FMRES_SUPERCEDE 
        } 
    } 
    return FMRES_IGNORED 
}